<?php
if(empty($_curr_page))
    $_curr_page = '';

if(empty($_head_nav))
    $_head_nav = [
        'home' => [
            'href' => './',
            'text' => 'Home',
        ],
        'downloads' => [
            'href' => './downloads.php',
            'text' => 'Downloads',
        ],
        'changelog' => [
            'href' => './changelog.php',
            'text' => 'Changelog',
        ],
        'repository' => [
            'href' => 'https://github.com/flashwave/topmostfriend',
            'text' => 'Repository',
        ],
    ];
?>
<!doctype html>
<html lang="en">
    <head>
        <meta charset="utf-8"/>
        <title><?=(empty($title) ? '' : ($title . ' :: '));?>Top Most Friend</title>
        <link href="style.css" rel="stylesheet" type="text/css"/>
        <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no"/>
<?php if(!empty($description)): ?>
        <meta name="description" content="<?=$description;?>"/>
<?php endif; ?>
    </head>
    <body>
        <div id="_tmf" class="tmf tmf--<?=$_curr_page;?>">
            <div class="tmf-head">
                <div class="tmf-head-nav">
<?php foreach($_head_nav as $id => $info): ?>
                    <li<?php if($id === $_curr_page) { echo ' class="current"'; } ?>><a href="<?=$info['href'];?>" id="_nav_<?=$id;?>"><?=$info['text'];?></a></li>
<?php endforeach; ?>
                </div>
                <div class="tmf-head-logo">
                    <h1>Top Most Friend</h1>
                </div>
            </div>
            <div class="tmf-body"><?=(!empty($body) ? $body : (function_exists('get_tmf_body') ? get_tmf_body() : ''));?></div>
            <div class="tmf-foot">
                &copy; <a href="//flash.moe">flashwave</a> 2020-<?=date("Y\r\n");?>
            </div>
        </div>
    </body>
</html>
